CC=cc
APP=ds
IDLFILE=ds.idl
FILE_PREFIX=ds
SYS_LDFLAGS=
POWERRPC_HOME=C:\POWERRPC\V1.1\TARGETS\DEMO

!include <ntwin32.mak>

#server specific user objects
USER_SERV_OBJS=

#client specific user objects
USER_CLNT_OBJS=$(APP)_call.obj

#objects shared by client and server
COMMON_OBJS=

CLNT_LD_FLAGS=
SERV_LD_FLAGS=api.lib

#this should be the path of the powerRPC executable
POWERRPC= $(POWERRPC_HOME)\bin\powerRPC
PWLIBDIR=$(POWERRPC_HOME)\win32lib

EXEDIR=$(APP)exe
DLLDIR=$(APP)dll

SERVLIB=$(DLLDIR)\$(FILE_PREFIX)Serv.lib
CLNTLIB =$(DLLDIR)\$(FILE_PREFIX)Clnt.lib

SERVDLL =$(DLLDIR)\$(FILE_PREFIX)Serv.dll
CLNTDLL =$(CLNTDLL)\$(FILE_PREFIX)Clnt.dll

SERVER_PROG=$(EXEDIR)\$(APP)srv.exe
CLIENT_PROG=$(EXEDIR)\$(APP)clt.exe

SERVER_PROG_DLINK = $(DLLDIR)\$(APP)srvd.exe
CLIENT_PROG_DLINK = $(DLLDIR)\$(APP)cltd.exe


!IF "$(OS)" == "Windows_NT"
NULL=
!ELSE
NULL=nul
!ENDIF

PWLDFLAG=$(PWLIBDIR)\pwrpc32.lib

all: $(EXEDIR) $(DLLDIR) server client
alldll: $(DLLDIR) $(CLNTDLL) $(SERVDLL) clientd

dll: $(DLLDIR) $(CLNTDLL) $(SERVDLL) 

$(DLLDIR):
	if not exist "$(DLLDIR)\$(NULL)" mkdir "$(DLLDIR)"

$(EXEDIR):
	if not exist "$(EXEDIR)\$(NULL)" mkdir "$(EXEDIR)"

server_lib: $(SERVLIB)
client_lib: $(CLNTLIB)
server: $(SERVER_PROG)
client: $(CLIENT_PROG)
serverd: $(SERVER_PROG_DLINK)
clientd: $(CLIENT_PROG_DLINK)
clean: 
	del  $(FILE_PREFIX)_svc.c
	del $(FILE_PREFIX)_cln.c 
	del $(FILE_PREFIX)_xdr.c
	del $(FILE_PREFIX).h
	del *.obj

$(FILE_PREFIX)_svc.c $(FILE_PREFIX)_cln.c $(FILE_PREFIX)_xdr.c: $(IDLFILE)
	$(POWERRPC) $(IDLFILE) 


$(CLNTLIB) $(CLNTDLL) : $(FILE_PREFIX)_cln.obj \
			$(FILE_PREFIX)_xdr.obj \
			$(COMMON_OBJS)
	$(link) $(lflags) /DLL -out:$(CLNTDLL) $(ldebug) \
	$(FILE_PREFIX)_cln.obj\
	$(FILE_PREFIX)_xdr.obj \
	$(COMMON_OBJS) \
	$(PWLDFLAG) $(conlibsdll) 


#To the generated DLL, you need to disable main() function
#generation, and call the exported XXX_main() function exported
#from the DLL elsewhere.

$(SERVLIB) $(SERVDLL) : \
		 $(FILE_PREFIX)_xdr.obj \
                 $(FILE_PREFIX)_svc.obj \
		 $(USER_SERV_OBJS)\
		 $(COMMON_OBJS) 
	       	$(link) $(lflags) /out:$(SERVDLL)\
		 /DLL /IMPLIB:$(SERVLIB) $(ldebug) \
		 $(FILE_PREFIX)_xdr.obj \
                 $(FILE_PREFIX)_svc.obj \
		 $(USER_SERV_OBJS)\
		 $(COMMON_OBJS) \
 		$(PWLDFLAG) $(lflags) $(conlibsdll)


$(SERVER_PROG): \
		 $(FILE_PREFIX)_xdr.obj \
                 $(FILE_PREFIX)_svc.obj \
		 $(USER_SERV_OBJS)\
		$(COMMON_OBJS)
	$(link) $(conlflags) /out:$@  \
	$(FILE_PREFIX)_xdr.obj \
        $(FILE_PREFIX)_svc.obj \
	$(USER_SERV_OBJS)\
	$(COMMON_OBJS)  \
	$(SERV_LD_FLAGS) $(SYS_LDFLAGS) $(PWLDFLAG) $(conlibsdll)

$(CLIENT_PROG): \
		 $(FILE_PREFIX)_xdr.obj \
                 $(FILE_PREFIX)_cln.obj \
		 $(USER_CLNT_OBJS)\
		 $(COMMON_OBJS) 
	$(link) $(conlflags) /out:$@\
		 $(FILE_PREFIX)_xdr.obj \
                 $(FILE_PREFIX)_cln.obj \
		 $(USER_CLNT_OBJS)\
		 $(COMMON_OBJS) \
	$(CLNT_LD_FLAGS) $(SYS_LDFLAGS) $(PWLDFLAG) $(conlibsdll)

#This is the executable which linked with the generated
# client DLL.

$(CLIENT_PROG_DLINK): \
		 $(USER_CLNT_OBJS)\
		 $(CLNTLIB) 
	$(link) $(conlflags) /out:$@\
		 $(USER_CLNT_OBJS)\
		 $(CLNTLIB) \
	$(CLNT_LD_FLAGS) $(SYS_LDFLAGS) $(PWLDFLAG) $(conlibsdll)



PWINCDIR=$(POWERRPC_HOME)\include\ 
PW_CC_FLAG= /I$(PWINCDIR)
CVV=  $(PW_CC_FLAG) -DWIN32 $(cdebug) $(cflags) $(cvarsdll) 

.c.obj:
    $(cc) $(CVV)  $*.c	

