/*-------------------------Copyright Notice ---------------------------------
                 Copyright (c) 1996  NETBULA, LLC
                    All Rights Reserved

This generated text is a part of the source code of a computer software.
It contains proprietary information and trade secrets of NETBULA, LLC.
No part of this copyrighted work may be reproduced or disclosed by any
means without the prior written permission from the copyright owner.

No part of this source code nor its compiled form may be used in a commercial
software unless authorized by a license agreement between you and the copyright
owner, Netbula, LLC.

Netbula, LLC is not liable under any theory for any direct or indirect damage
resulted from using this generated source code.

For license information, please contact Netbula at:
Netbula, LLC  P.O. Box 99335 Emeryville CA 94662 USA
----------------------------------------------------------------------------*/
#define POWERRPC_XDR
#define POWERRPC_SERVER
#include "ds.h"
#include <rpc/pmap_cln.h>
static char *version_str="@(#)powerRPC V1.1 MxTF! system: WIN32";
;
static SVCXPRT* tcp_master = 0;
static SVCXPRT* udp_master = 0;

static void no_op(void*p) {}

void ds_1(struct svc_req* rqstp,SVCXPRT* txp){

	union {
		printmsg_in_t	printmsg_OVER;
		int	__pwrpc_dummy___;
	}RPC_over;

	union {
		int	__pwrpc_dummy___;
	}RPC_back;

	pwrpc_call_struct callInfo;
	callInfo.ptransport = txp;
	callInfo.pover = (caddr_t)&RPC_over;
	callInfo.pback = (caddr_t)&RPC_back;
	callInfo.reply_now = 0;
	callInfo.mt_on_call = 0;
	callInfo.free_after = 0;
	callInfo.psvc_req = rqstp;
	callInfo.proc = 0;


	switch (rqstp->rq_proc) {
	case NULLPROC:
		svc_sendreply(txp, (xdrproc_t)xdr_void, 0);
		return;

	case PRINTMSG:
		callInfo.xdr_over = (xdrproc_t) xdr_printmsg_in_t;
		callInfo.xdr_back = (xdrproc_t) xdr_void;
		callInfo.over_size = sizeof(printmsg_in_t);
		callInfo.back_size = 0;
		callInfo.local = (local_call_t)printmsg_call;
		callInfo.free_after = (free_call_t)0;
		break;

	default:
		svcerr_noproc(txp);
		return;
	}

	pw_serv_call(&callInfo);

}

SVCXPRT*	ds_1_reg(int sock, unsigned long prog_no, unsigned long ver, int proto) {
	int prot = 0;
	SVCXPRT * txp =0;

	if(proto==IPPROTO_TCP) {
		tcp_master = svctcp_create(sock, 0, 0);
		if(tcp_master==NULL) {
			server_err("fail creating TCP server transport!\n");
			return (SVCXPRT*)0;
		}
	}
	if(proto==IPPROTO_UDP) {
		udp_master = svcudp_create(sock);
		if(udp_master==NULL) {
		server_err("fail creating UDP server transport!\n");
			return (SVCXPRT*)0;
		}
	}
	prog_no = prog_no == 0? DS : prog_no;
	ver  = ver == 0? DS_1 : ver;
	txp = proto==IPPROTO_TCP? tcp_master : udp_master;
	if (!svc_register(txp, prog_no, ver, ds_1, prot)) {
		server_err("Fail to register server!\n");
		return (SVCXPRT*)0;
	}
	return txp;
}

void	ds_1_unmap(unsigned long prog_no, unsigned long ver) {
	 pmap_unset(
	                prog_no==0? DS: prog_no,
	                ver==0? DS_1: ver
	               );
}


void	ds_1_main(int argc, char ** argv) {
	int sock = RPC_ANYSOCK;

	unsigned long prog_no=0;

	int fork_connect = 0;
	int exit_idle = 1;

	pw_serv_init();

	sock = pw_serv_fd(3456, "tcp");
	if(!ds_1_reg(sock, 0, 0, IPPROTO_TCP))
		server_exit(1);
	server_msg("TCP server registered.\n");
	sock = pw_serv_fd(3456, "udp");
	if(!ds_1_reg(sock, 0, 0, IPPROTO_UDP))
		server_exit(1);
	server_msg("UDP server registered.\n");

	pw_serv_mainloop(tcp_master, udp_master, fork_connect, exit_idle);
}

int	main(int argc, char**argv){
			ds_1_main(argc, argv);
			return 0;
}

void	printmsg_call(struct printmsg_in_t* pIn){

	printmsg(
		pIn->msg
	);
}


