/*-------------------------Copyright Notice ---------------------------------
                 Copyright (c) 1996  NETBULA, LLC
                    All Rights Reserved

This generated text is a part of the source code of a computer software.
It contains proprietary information and trade secrets of NETBULA, LLC.
No part of this copyrighted work may be reproduced or disclosed by any
means without the prior written permission from the copyright owner.

No part of this source code nor its compiled form may be used in a commercial
software unless authorized by a license agreement between you and the copyright
owner, Netbula, LLC.

Netbula, LLC is not liable under any theory for any direct or indirect damage
resulted from using this generated source code.

For license information, please contact Netbula at:
Netbula, LLC  P.O. Box 99335 Emeryville CA 94662 USA
----------------------------------------------------------------------------*/
#include <rpc/rpc.h>
#include <malloc.h>
#include <stdio.h>
typedef char*	str1024;

typedef struct fHandle{
	int	fd;
}rFILE;

typedef u_long	size_T;

typedef char	c_arr1024[1024];

typedef struct dentry{
	c_arr1024	name;
	struct dentry*	next;
}DENTRY;

bool_t xdr_str1024(XDR*, str1024*);

#define str1024_freeres( pstr1024 ) \
 do { if(pstr1024) xdr_free ( (xdrproc_t)xdr_str1024,(char*)pstr1024);}while(0)

bool_t xdr_fHandle(XDR*, struct fHandle*);

#define fHandle_freeres( pfHandle ) \
 do { if(pfHandle) xdr_free ( (xdrproc_t)xdr_fHandle,(char*)pfHandle);}while(0)

bool_t xdr_rFILE(XDR*, rFILE*);

#define rFILE_freeres( prFILE ) \
 do { if(prFILE) xdr_free ( (xdrproc_t)xdr_rFILE,(char*)prFILE);}while(0)

bool_t xdr_size_T(XDR*, size_T*);

#define size_T_freeres( psize_T ) \
 do { if(psize_T) xdr_free ( (xdrproc_t)xdr_size_T,(char*)psize_T);}while(0)

bool_t xdr_c_arr1024(XDR*, c_arr1024*);

#define c_arr1024_freeres( pc_arr1024 ) \
 do { if(pc_arr1024) xdr_free ( (xdrproc_t)xdr_c_arr1024,(char*)pc_arr1024);}while(0)

bool_t xdr_dentry(XDR*, struct dentry*);

#define dentry_freeres( pdentry ) \
 do { if(pdentry) xdr_free ( (xdrproc_t)xdr_dentry,(char*)pdentry);}while(0)

bool_t xdr_DENTRY(XDR*, DENTRY*);

#define DENTRY_freeres( pDENTRY ) \
 do { if(pDENTRY) xdr_free ( (xdrproc_t)xdr_DENTRY,(char*)pDENTRY);}while(0)

#define RFOPEN  (unsigned long)(1)
#define RFREAD  (unsigned long)(2)
#define RFWRITE  (unsigned long)(3)
#define RFCLOSE  (unsigned long)(4)
#define RLISTDIR  (unsigned long)(5)
#define RCHDIR  (unsigned long)(6)
#define RFILE_5  (unsigned long)(5)
#define RFILE  (unsigned long)(21845)
#ifndef POWERRPC_COMMON_H
#define POWERRPC_COMMON_H
#define ERR_NULL_CLNT -125
#define server_err(x) fprintf(stderr, x)
#define MEM_ASSERT(P) {if(P==0){server_err("Memory exhausted!"); return 0;}}
#define server_msg(x) fprintf(stderr, x)
#define server_exit(x) exit(x)
#endif


#ifdef POWERRPC_XDR

typedef struct rfopen_in_t{
	str1024	filename;
	str1024	mode;
}rfopen_in_t;

typedef struct rfopen_out_t{
	rFILE*	_pwrpc_return_;
}rfopen_out_t;

typedef struct rfread_in_t{
	size_T	size;
	size_T	nm;
	rFILE*	stream;
}rfread_in_t;

typedef struct rfread_out_t{
	size_T	size;
	size_T	nm;
	void*	ptr;
	int	_pwrpc_return_;
}rfread_out_t;

typedef struct rfwrite_in_t{
	size_T	nm;
	size_T	size;
	void*	ptr;
	rFILE*	stream;
}rfwrite_in_t;

typedef struct rfwrite_out_t{
	int	_pwrpc_return_;
}rfwrite_out_t;

typedef struct rfclose_in_t{
	rFILE*	stream;
}rfclose_in_t;

typedef struct rfclose_out_t{
	int	_pwrpc_return_;
}rfclose_out_t;

typedef struct rlistdir_in_t{
	str1024	path;
}rlistdir_in_t;

typedef struct rlistdir_out_t{
	DENTRY*	pent;
	int	_pwrpc_return_;
}rlistdir_out_t;

typedef struct rchdir_in_t{
	str1024	path;
}rchdir_in_t;

typedef struct rchdir_out_t{
	int	_pwrpc_return_;
}rchdir_out_t;

bool_t xdr_rfopen_in_t(XDR*, struct rfopen_in_t*);
bool_t xdr_rfopen_out_t(XDR*, struct rfopen_out_t*);
bool_t xdr_rfread_in_t(XDR*, struct rfread_in_t*);
bool_t xdr_rfread_out_t(XDR*, struct rfread_out_t*);
bool_t xdr_rfwrite_in_t(XDR*, struct rfwrite_in_t*);
bool_t xdr_rfwrite_out_t(XDR*, struct rfwrite_out_t*);
bool_t xdr_rfclose_in_t(XDR*, struct rfclose_in_t*);
bool_t xdr_rfclose_out_t(XDR*, struct rfclose_out_t*);
bool_t xdr_rlistdir_in_t(XDR*, struct rlistdir_in_t*);
bool_t xdr_rlistdir_out_t(XDR*, struct rlistdir_out_t*);
bool_t xdr_rchdir_in_t(XDR*, struct rchdir_in_t*);
bool_t xdr_rchdir_out_t(XDR*, struct rchdir_out_t*);

#endif


#ifdef POWERRPC_CLIENT

int	rfopen_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rfopen_in_t* pIn, struct rfopen_out_t* pOut);
int	rfread_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rfread_in_t* pIn, struct rfread_out_t* pOut);
int	rfwrite_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rfwrite_in_t* pIn, struct rfwrite_out_t* pOut);
int	rfclose_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rfclose_in_t* pIn, struct rfclose_out_t* pOut);
int	rlistdir_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rlistdir_in_t* pIn, struct rlistdir_out_t* pOut);
int	rchdir_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rchdir_in_t* pIn, struct rchdir_out_t* pOut);
void	rfile_bind_handle(CLIENT* pclnt);

CLIENT*	rfile_bind(char* host, u_long prog, u_long ver,char* proto);

void	rfile_unbind(CLIENT* pclnt);


#endif


#ifdef POWERRPC_SERVER

void	rfopen_call(struct rfopen_in_t* pIn, struct rfopen_out_t* pOut);
int	malloc_rfread_out_t(struct rfread_out_t* pVar);
void	mfree_rfread_out_t(struct rfread_out_t* pVar);
void	rfread_call(struct rfread_in_t* pIn, struct rfread_out_t* pOut);
void	rfwrite_call(struct rfwrite_in_t* pIn, struct rfwrite_out_t* pOut);
void	rfclose_call(struct rfclose_in_t* pIn, struct rfclose_out_t* pOut);
int	malloc_rlistdir_out_t(struct rlistdir_out_t* pVar);
void	mfree_rlistdir_out_t(struct rlistdir_out_t* pVar);
void	rlistdir_call(struct rlistdir_in_t* pIn, struct rlistdir_out_t* pOut);
void	rchdir_call(struct rchdir_in_t* pIn, struct rchdir_out_t* pOut);
void rfile_5(struct svc_req* rqstp,SVCXPRT* txp);
SVCXPRT*	rfile_5_reg(int sock, unsigned long prog_no, unsigned long ver, unsigned long proto);
void	rfile_5_unmap(unsigned long prog_no, unsigned long ver);

#endif

#define RFILE_5_HANDLE RFILE_5_handle
#define RFILE_5_TIMEOUT RFILE_5_timeout
rFILE*	rfopen(const str1024	filename, const str1024	mode);
int	rfread(void*	ptr, size_T	size, size_T	nm, rFILE*	stream);
int	rfwrite(const void*	ptr, size_T	size, size_T	nm, rFILE*	stream);
int	rfclose(rFILE*	stream);
int	rlistdir(str1024	path, DENTRY*	pent);
int	rchdir(str1024	path);
CLIENT*	rfile_bind(char* host, u_long prog, u_long ver,char* proto);
void	rfile_unbind(CLIENT* pclnt);
void	rfile_bind_handle(CLIENT* pclnt);
SVCXPRT*	rfile_5_reg(int sock, unsigned long prog_no, unsigned long ver, unsigned long proto);

void	rfile_5_unmap(unsigned long prog_no, unsigned long ver);

#include <powerrpc.h>
