/*-------------------------Copyright Notice ---------------------------------
                 Copyright (c) 1996  NETBULA, LLC
                    All Rights Reserved

This generated text is a part of the source code of a computer software.
It contains proprietary information and trade secrets of NETBULA, LLC.
No part of this copyrighted work may be reproduced or disclosed by any
means without the prior written permission from the copyright owner.

No part of this source code nor its compiled form may be used in a commercial
software unless authorized by a license agreement between you and the copyright
owner, Netbula, LLC.

Netbula, LLC is not liable under any theory for any direct or indirect damage
resulted from using this generated source code.

For license information, please contact Netbula at:
Netbula, LLC  P.O. Box 99335 Emeryville CA 94662 USA
----------------------------------------------------------------------------*/
#define POWERRPC_XDR
#define POWERRPC_CLIENT
#include "rfile.h"
static char *version_str="@(#)powerRPC V1.1 MxTF";
;
CLIENT* RFILE_5_handle = 0;
struct timeval RFILE_5_timeout = {60, 0};
int	rfopen_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rfopen_in_t* pIn, struct rfopen_out_t* pOut){
	int ret_code;
	if(pclnt==(CLIENT*)0) {
		return ERR_NULL_CLNT;
	}
	ret_code = clnt_call(pclnt,
	                     RFOPEN,
	                     (xdrproc_t)xdr_rfopen_in_t,
	                     (void*)pIn,
	                     (xdrproc_t)xdr_rfopen_out_t,
	                     (void*)pOut,
	                     *ptimeout
	                    );

	if(ret_code != RPC_SUCCESS) {
		clnt_perror(pclnt,"rfopen");
	}
	return ret_code;
}

rFILE*	rfopen(const str1024	filename, const str1024	mode){
	rfopen_in_t	Input;
	rfopen_out_t	Output;

	struct timeval timeOut;
	memset(&Output, 0, sizeof(Output));
	Input.filename = filename;
	Input.mode = mode;

	timeOut = RFILE_5_TIMEOUT;
	rfopen_wrap(RFILE_5_HANDLE, &timeOut, &Input, &Output);

	return Output._pwrpc_return_;
}

int	rfread_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rfread_in_t* pIn, struct rfread_out_t* pOut){
	int ret_code;
	if(pclnt==(CLIENT*)0) {
		return ERR_NULL_CLNT;
	}
	ret_code = clnt_call(pclnt,
	                     RFREAD,
	                     (xdrproc_t)xdr_rfread_in_t,
	                     (void*)pIn,
	                     (xdrproc_t)xdr_rfread_out_t,
	                     (void*)pOut,
	                     *ptimeout
	                    );

	if(ret_code != RPC_SUCCESS) {
		clnt_perror(pclnt,"rfread");
	}
	return ret_code;
}

int	rfread(void*	ptr, size_T	size, size_T	nm, rFILE*	stream){
	rfread_in_t	Input;
	rfread_out_t	Output;

	struct timeval timeOut;
	memset(&Output, 0, sizeof(Output));
	Output.ptr = ptr;
	Input.size = size;
	Input.nm = nm;
	Input.stream = stream;

	timeOut = RFILE_5_TIMEOUT;
	rfread_wrap(RFILE_5_HANDLE, &timeOut, &Input, &Output);

	return Output._pwrpc_return_;
}

int	rfwrite_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rfwrite_in_t* pIn, struct rfwrite_out_t* pOut){
	int ret_code;
	if(pclnt==(CLIENT*)0) {
		return ERR_NULL_CLNT;
	}
	ret_code = clnt_call(pclnt,
	                     RFWRITE,
	                     (xdrproc_t)xdr_rfwrite_in_t,
	                     (void*)pIn,
	                     (xdrproc_t)xdr_rfwrite_out_t,
	                     (void*)pOut,
	                     *ptimeout
	                    );

	if(ret_code != RPC_SUCCESS) {
		clnt_perror(pclnt,"rfwrite");
	}
	return ret_code;
}

int	rfwrite(const void*	ptr, size_T	size, size_T	nm, rFILE*	stream){
	rfwrite_in_t	Input;
	rfwrite_out_t	Output;

	struct timeval timeOut;
	memset(&Output, 0, sizeof(Output));
	Input.ptr = ptr;
	Input.size = size;
	Input.nm = nm;
	Input.stream = stream;

	timeOut = RFILE_5_TIMEOUT;
	rfwrite_wrap(RFILE_5_HANDLE, &timeOut, &Input, &Output);

	return Output._pwrpc_return_;
}

int	rfclose_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rfclose_in_t* pIn, struct rfclose_out_t* pOut){
	int ret_code;
	if(pclnt==(CLIENT*)0) {
		return ERR_NULL_CLNT;
	}
	ret_code = clnt_call(pclnt,
	                     RFCLOSE,
	                     (xdrproc_t)xdr_rfclose_in_t,
	                     (void*)pIn,
	                     (xdrproc_t)xdr_rfclose_out_t,
	                     (void*)pOut,
	                     *ptimeout
	                    );

	if(ret_code != RPC_SUCCESS) {
		clnt_perror(pclnt,"rfclose");
	}
	return ret_code;
}

int	rfclose(rFILE*	stream){
	rfclose_in_t	Input;
	rfclose_out_t	Output;

	struct timeval timeOut;
	memset(&Output, 0, sizeof(Output));
	Input.stream = stream;

	timeOut = RFILE_5_TIMEOUT;
	rfclose_wrap(RFILE_5_HANDLE, &timeOut, &Input, &Output);

	return Output._pwrpc_return_;
}

int	rlistdir_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rlistdir_in_t* pIn, struct rlistdir_out_t* pOut){
	int ret_code;
	if(pclnt==(CLIENT*)0) {
		return ERR_NULL_CLNT;
	}
	ret_code = clnt_call(pclnt,
	                     RLISTDIR,
	                     (xdrproc_t)xdr_rlistdir_in_t,
	                     (void*)pIn,
	                     (xdrproc_t)xdr_rlistdir_out_t,
	                     (void*)pOut,
	                     *ptimeout
	                    );

	if(ret_code != RPC_SUCCESS) {
		clnt_perror(pclnt,"rlistdir");
	}
	return ret_code;
}

int	rlistdir(str1024	path, DENTRY*	pent){
	rlistdir_in_t	Input;
	rlistdir_out_t	Output;

	struct timeval timeOut;
	memset(&Output, 0, sizeof(Output));
	Input.path = path;
	Output.pent = pent;

	timeOut.tv_usec = 0;
	timeOut.tv_sec = 2;
	rlistdir_wrap(RFILE_5_HANDLE, &timeOut, &Input, &Output);

	return Output._pwrpc_return_;
}

int	rchdir_wrap(CLIENT* pclnt, struct timeval* ptimeout, struct rchdir_in_t* pIn, struct rchdir_out_t* pOut){
	int ret_code;
	if(pclnt==(CLIENT*)0) {
		return ERR_NULL_CLNT;
	}
	ret_code = clnt_call(pclnt,
	                     RCHDIR,
	                     (xdrproc_t)xdr_rchdir_in_t,
	                     (void*)pIn,
	                     (xdrproc_t)xdr_rchdir_out_t,
	                     (void*)pOut,
	                     *ptimeout
	                    );

	if(ret_code != RPC_SUCCESS) {
		clnt_perror(pclnt,"rchdir");
	}
	return ret_code;
}

int	rchdir(str1024	path){
	rchdir_in_t	Input;
	rchdir_out_t	Output;

	struct timeval timeOut;
	memset(&Output, 0, sizeof(Output));
	Input.path = path;

	timeOut = RFILE_5_TIMEOUT;
	rchdir_wrap(RFILE_5_HANDLE, &timeOut, &Input, &Output);

	return Output._pwrpc_return_;
}

CLIENT*	rfile_bind(char* host, u_long prog, u_long ver,char* proto) {
	char * protoc = "tcp";
	ver = (ver==0? RFILE_5 : ver);
	prog = (prog==0? RFILE : prog );
	protoc = (proto==(char*)0? protoc : proto);
	RFILE_5_handle = pw_clnt_create(host, 5431, prog, ver, protoc, 0, 0);
	return RFILE_5_handle;
}

void	rfile_bind_handle(CLIENT* pclnt){
	RFILE_5_handle = pclnt;
}

void	rfile_unbind(CLIENT* pclnt) {
	pclnt  = (pclnt==0? RFILE_5_handle: pclnt);
	if(pclnt)
		clnt_destroy(pclnt);
}

