/*-------------------------Copyright Notice ---------------------------------
                 Copyright (c) 1996  NETBULA, LLC
                    All Rights Reserved

This generated text is a part of the source code of a computer software.
It contains proprietary information and trade secrets of NETBULA, LLC.
No part of this copyrighted work may be reproduced or disclosed by any
means without the prior written permission from the copyright owner.

No part of this source code nor its compiled form may be used in a commercial
software unless authorized by a license agreement between you and the copyright
owner, Netbula, LLC.

Netbula, LLC is not liable under any theory for any direct or indirect damage
resulted from using this generated source code.

For license information, please contact Netbula at:
Netbula, LLC  P.O. Box 99335 Emeryville CA 94662 USA
----------------------------------------------------------------------------*/
#define POWERRPC_XDR
#define POWERRPC_SERVER
#include "rfile.h"
#include <rpc/pmap_cln.h>
static char *version_str="@(#)powerRPC V1.1 MxTF";
;
static SVCXPRT* tcp_master = 0;
static SVCXPRT* udp_master = 0;

static void no_op(void*p) {}

void rfile_5(struct svc_req* rqstp,SVCXPRT* txp){

	union {
		rfopen_in_t	rfopen_OVER;
		rfread_in_t	rfread_OVER;
		rfwrite_in_t	rfwrite_OVER;
		rfclose_in_t	rfclose_OVER;
		rlistdir_in_t	rlistdir_OVER;
		rchdir_in_t	rchdir_OVER;
	}RPC_over;

	union {
		rfopen_out_t	rfopen_BACK;
		rfread_out_t	rfread_BACK;
		rfwrite_out_t	rfwrite_BACK;
		rfclose_out_t	rfclose_BACK;
		rlistdir_out_t	rlistdir_BACK;
		rchdir_out_t	rchdir_BACK;
	}RPC_back;

	pwrpc_call_struct callInfo;
	callInfo.ptransport = txp;
	callInfo.pover = (caddr_t)&RPC_over;
	callInfo.over_size = sizeof(RPC_over);
	callInfo.pback = (caddr_t)&RPC_back;
	callInfo.back_size = sizeof(RPC_back);
	callInfo.reply_now = 0;
	callInfo.fork_on_call = 0;
	callInfo.free_after = 0;
	callInfo.psvc_req = rqstp;
	callInfo.proc = 0;


	switch (rqstp->rq_proc) {
	case NULLPROC:
		svc_sendreply(txp, (xdrproc_t)xdr_void, 0);
		return;

	case RFOPEN:
		callInfo.xdr_over = (xdrproc_t) xdr_rfopen_in_t;
		callInfo.xdr_back = (xdrproc_t) xdr_rfopen_out_t;
		callInfo.local = (local_call_t)rfopen_call;
		callInfo.free_after = (free_call_t)0;
		callInfo.fork_on_call = 1;
		break;

	case RFREAD:
		callInfo.xdr_over = (xdrproc_t) xdr_rfread_in_t;
		callInfo.xdr_back = (xdrproc_t) xdr_rfread_out_t;
		callInfo.local = (local_call_t)rfread_call;
		callInfo.free_after = (free_call_t)mfree_rfread_out_t;
		callInfo.fork_on_call = 1;
		break;

	case RFWRITE:
		callInfo.xdr_over = (xdrproc_t) xdr_rfwrite_in_t;
		callInfo.xdr_back = (xdrproc_t) xdr_rfwrite_out_t;
		callInfo.local = (local_call_t)rfwrite_call;
		callInfo.free_after = (free_call_t)0;
		callInfo.fork_on_call = 1;
		break;

	case RFCLOSE:
		callInfo.xdr_over = (xdrproc_t) xdr_rfclose_in_t;
		callInfo.xdr_back = (xdrproc_t) xdr_rfclose_out_t;
		callInfo.local = (local_call_t)rfclose_call;
		callInfo.free_after = (free_call_t)0;
		callInfo.fork_on_call = 1;
		break;

	case RLISTDIR:
		callInfo.xdr_over = (xdrproc_t) xdr_rlistdir_in_t;
		callInfo.xdr_back = (xdrproc_t) xdr_rlistdir_out_t;
		callInfo.local = (local_call_t)rlistdir_call;
		callInfo.free_after = (free_call_t)mfree_rlistdir_out_t;
		callInfo.fork_on_call = 1;
		break;

	case RCHDIR:
		callInfo.xdr_over = (xdrproc_t) xdr_rchdir_in_t;
		callInfo.xdr_back = (xdrproc_t) xdr_rchdir_out_t;
		callInfo.local = (local_call_t)rchdir_call;
		callInfo.free_after = (free_call_t)0;
		callInfo.fork_on_call = 1;
		break;

	default:
		svcerr_noproc(txp);
		return;
	}

	pw_serv_call(&callInfo);

}

SVCXPRT*	rfile_5_reg(int sock, unsigned long prog_no, unsigned long ver, unsigned long proto) {
	unsigned long prot = 0;
	SVCXPRT * txp =0;

	if(proto==IPPROTO_TCP) {
		tcp_master = svctcp_create(sock, 0, 0);
		if(tcp_master==NULL) {
			server_err("fail creating TCP server transport!\n");
			return (SVCXPRT*)0;
		}
	}
	if(proto==IPPROTO_UDP) {
		udp_master = svcudp_create(sock);
		if(udp_master==NULL) {
		server_err("fail creating UDP server transport!\n");
			return (SVCXPRT*)0;
		}
	}
	prot = sock==0 ? 0 : proto;
	prog_no = prog_no == 0? RFILE : prog_no;
	ver  = ver == 0? RFILE_5 : ver;
	txp = proto==IPPROTO_TCP? tcp_master : udp_master;
	if (!svc_register(txp, prog_no, ver, rfile_5, prot)) {
		server_err("Fail to register server!\n");
		return (SVCXPRT*)0;
	}
	return txp;
}

void	rfile_5_unmap(unsigned long prog_no, unsigned long ver) {
	 pmap_unset(
	                prog_no==0? RFILE: prog_no,
	                ver==0? RFILE_5: ver
	               );
}


void	rfile_5_main(int argc, char ** argv) {
	int sock = RPC_ANYSOCK;

	unsigned long prog_no=0;
	int fork_connect = 0;
	int exit_idle = 1;
	{
	void init_fdtable(int, char**);

	init_fdtable(argc, argv);
	}

	if(sock!=0)
		pmap_unset(RFILE, RFILE_5);

	pw_serv_init();

	sock = pw_serv_fd(5431, "tcp");
	if(!rfile_5_reg(sock, 0, 0, IPPROTO_TCP))
		server_exit(1);
	server_msg("TCP server registered.\n");

	pw_serv_mainloop(tcp_master, udp_master, fork_connect, exit_idle);
}

int	main(int argc, char**argv){
			rfile_5_main(argc, argv);
			return 0;
}

void	rfopen_call(struct rfopen_in_t* pIn, struct rfopen_out_t* pOut){
	memset(pOut, 0, sizeof(rfopen_out_t));

	pOut->_pwrpc_return_ =
	rfopen(
		pIn->filename,
		pIn->mode
	);
}


int malloc_rfread_out_t(struct rfread_out_t* pVar){
	pVar->ptr = (void*) malloc((pVar->size*pVar->nm));
	MEM_ASSERT(pVar->ptr);
	memset(pVar->ptr, 0, (pVar->size*pVar->nm));
	return (1);
}


void	mfree_rfread_out_t(struct rfread_out_t* pVar){
	free(pVar->ptr);
	return;
}


void	rfread_call(struct rfread_in_t* pIn, struct rfread_out_t* pOut){
	memset(pOut, 0, sizeof(rfread_out_t));
	pOut->size = pIn->size;
	pOut->nm = pIn->nm;
	malloc_rfread_out_t(pOut);

	pOut->_pwrpc_return_ =
	rfread(
		pOut->ptr,
		pIn->size,
		pIn->nm,
		pIn->stream
	);
}


void	rfwrite_call(struct rfwrite_in_t* pIn, struct rfwrite_out_t* pOut){
	memset(pOut, 0, sizeof(rfwrite_out_t));

	pOut->_pwrpc_return_ =
	rfwrite(
		pIn->ptr,
		pIn->size,
		pIn->nm,
		pIn->stream
	);
}


void	rfclose_call(struct rfclose_in_t* pIn, struct rfclose_out_t* pOut){
	memset(pOut, 0, sizeof(rfclose_out_t));

	pOut->_pwrpc_return_ =
	rfclose(
		pIn->stream
	);
}


int malloc_rlistdir_out_t(struct rlistdir_out_t* pVar){
	pVar->pent = (DENTRY*) malloc(sizeof(DENTRY));
	MEM_ASSERT(pVar->pent);
	memset(pVar->pent, 0, sizeof(*pVar->pent));
	return (1);
}


void	mfree_rlistdir_out_t(struct rlistdir_out_t* pVar){
	free(pVar->pent);
	return;
}


void	rlistdir_call(struct rlistdir_in_t* pIn, struct rlistdir_out_t* pOut){
	memset(pOut, 0, sizeof(rlistdir_out_t));
	malloc_rlistdir_out_t(pOut);

	pOut->_pwrpc_return_ =
	rlistdir(
		pIn->path,
		pOut->pent
	);
}


void	rchdir_call(struct rchdir_in_t* pIn, struct rchdir_out_t* pOut){
	memset(pOut, 0, sizeof(rchdir_out_t));

	pOut->_pwrpc_return_ =
	rchdir(
		pIn->path
	);
}


