/*-------------------------Copyright Notice ---------------------------------
                 Copyright (c) 1996  NETBULA, LLC
                    All Rights Reserved

This generated text is a part of the source code of a computer software.
It contains proprietary information and trade secrets of NETBULA, LLC.
No part of this copyrighted work may be reproduced or disclosed by any
means without the prior written permission from the copyright owner.

No part of this source code nor its compiled form may be used in a commercial
software unless authorized by a license agreement between you and the copyright
owner, Netbula, LLC.

Netbula, LLC is not liable under any theory for any direct or indirect damage
resulted from using this generated source code.

For license information, please contact Netbula at:
Netbula, LLC  P.O. Box 99335 Emeryville CA 94662 USA
----------------------------------------------------------------------------*/
#define POWERRPC_XDR
#include "rfile.h"
static char *version_str="@(#)powerRPC V1.1 MxTF";
;
bool_t xdr_str1024(XDR*xdrp, str1024* pstr1024){
	{
	unsigned int len; 
	unsigned int maxlen = 1024;
	if(xdrp->x_op != XDR_DECODE)
		len = (strlen((*pstr1024))+1);
	if(!xdr_bytes(xdrp, (char**)pstr1024, &len, maxlen))
		return 0;
	}
		return 1;
}


bool_t xdr_fHandle(XDR*xdrp, struct fHandle* pfHandle){

	if(!xdr_int(xdrp, &pfHandle->fd))
		return 0;

	return 1;
}

bool_t xdr_rFILE(XDR*xdrp, rFILE* prFILE){
	if(!xdr_fHandle(xdrp, prFILE))
		return 0;
		return 1;
}

bool_t xdr_size_T(XDR*xdrp, size_T* psize_T){
	if(!xdr_u_long(xdrp, psize_T))
		return 0;
		return 1;
}

bool_t xdr_c_arr1024(XDR*xdrp, c_arr1024* pc_arr1024){
	{
	unsigned int maxlen = 1024;
	maxlen = (strlen((*pc_arr1024))+1);
	if(!xdr_u_int(xdrp, &maxlen))
		return 0;
	if(!xdr_opaque(xdrp, (char*)pc_arr1024, maxlen))
		return 0;
	}
		return 1;
}


bool_t xdr_dentry(XDR*xdrp, struct dentry* pdentry){

	if(!xdr_c_arr1024(xdrp, &pdentry->name))
		return 0;
	if(!xdr_pointer(xdrp, (char**)&pdentry->next, sizeof(struct dentry), (xdrproc_t)xdr_dentry))
		return 0;

	return 1;
}

bool_t xdr_DENTRY(XDR*xdrp, DENTRY* pDENTRY){
	if(!xdr_dentry(xdrp, pDENTRY))
		return 0;
		return 1;
}


bool_t xdr_rfopen_in_t(XDR*xdrp, struct rfopen_in_t* prfopen_in_t){

	if(!xdr_str1024(xdrp, &prfopen_in_t->filename))
		return 0;
	if(!xdr_str1024(xdrp, &prfopen_in_t->mode))
		return 0;

	return 1;
}


bool_t xdr_rfopen_out_t(XDR*xdrp, struct rfopen_out_t* prfopen_out_t){

	if(!xdr_pointer(xdrp, (char**)&prfopen_out_t->_pwrpc_return_, sizeof(rFILE), (xdrproc_t)xdr_rFILE))
		return 0;

	return 1;
}


bool_t xdr_rfread_in_t(XDR*xdrp, struct rfread_in_t* prfread_in_t){

	if(!xdr_size_T(xdrp, &prfread_in_t->size))
		return 0;
	if(!xdr_size_T(xdrp, &prfread_in_t->nm))
		return 0;
	if(!xdr_pointer(xdrp, (char**)&prfread_in_t->stream, sizeof(rFILE), (xdrproc_t)xdr_rFILE))
		return 0;

	return 1;
}


bool_t xdr_rfread_out_t(XDR*xdrp, struct rfread_out_t* prfread_out_t){

	if(!xdr_size_T(xdrp, &prfread_out_t->size))
		return 0;
	if(!xdr_size_T(xdrp, &prfread_out_t->nm))
		return 0;
	{
	unsigned int len; 
	unsigned int maxlen = (prfread_out_t->size*prfread_out_t->nm);
	if(xdrp->x_op != XDR_DECODE)
		len = ((prfread_out_t->_pwrpc_return_>0) ? prfread_out_t->_pwrpc_return_ : 0);
	if(!xdr_bytes(xdrp, (char**)&prfread_out_t->ptr, &len, maxlen))
		return 0;
	}
	if(!xdr_int(xdrp, &prfread_out_t->_pwrpc_return_))
		return 0;

	return 1;
}


bool_t xdr_rfwrite_in_t(XDR*xdrp, struct rfwrite_in_t* prfwrite_in_t){

	if(!xdr_size_T(xdrp, &prfwrite_in_t->nm))
		return 0;
	if(!xdr_size_T(xdrp, &prfwrite_in_t->size))
		return 0;
	{
	unsigned int len; 
	unsigned int maxlen = (prfwrite_in_t->size*prfwrite_in_t->nm);
	if(xdrp->x_op != XDR_DECODE)
		len = (prfwrite_in_t->nm*prfwrite_in_t->size);
	if(!xdr_bytes(xdrp, (char**)&prfwrite_in_t->ptr, &len, maxlen))
		return 0;
	}
	if(!xdr_pointer(xdrp, (char**)&prfwrite_in_t->stream, sizeof(rFILE), (xdrproc_t)xdr_rFILE))
		return 0;

	return 1;
}


bool_t xdr_rfwrite_out_t(XDR*xdrp, struct rfwrite_out_t* prfwrite_out_t){

	if(!xdr_int(xdrp, &prfwrite_out_t->_pwrpc_return_))
		return 0;

	return 1;
}


bool_t xdr_rfclose_in_t(XDR*xdrp, struct rfclose_in_t* prfclose_in_t){

	if(!xdr_pointer(xdrp, (char**)&prfclose_in_t->stream, sizeof(rFILE), (xdrproc_t)xdr_rFILE))
		return 0;

	return 1;
}


bool_t xdr_rfclose_out_t(XDR*xdrp, struct rfclose_out_t* prfclose_out_t){

	if(!xdr_int(xdrp, &prfclose_out_t->_pwrpc_return_))
		return 0;

	return 1;
}


bool_t xdr_rlistdir_in_t(XDR*xdrp, struct rlistdir_in_t* prlistdir_in_t){

	if(!xdr_str1024(xdrp, &prlistdir_in_t->path))
		return 0;

	return 1;
}


bool_t xdr_rlistdir_out_t(XDR*xdrp, struct rlistdir_out_t* prlistdir_out_t){

	if(!xdr_pointer(xdrp, (char**)&prlistdir_out_t->pent, sizeof(DENTRY), (xdrproc_t)xdr_DENTRY))
		return 0;
	if(!xdr_int(xdrp, &prlistdir_out_t->_pwrpc_return_))
		return 0;

	return 1;
}


bool_t xdr_rchdir_in_t(XDR*xdrp, struct rchdir_in_t* prchdir_in_t){

	if(!xdr_str1024(xdrp, &prchdir_in_t->path))
		return 0;

	return 1;
}


bool_t xdr_rchdir_out_t(XDR*xdrp, struct rchdir_out_t* prchdir_out_t){

	if(!xdr_int(xdrp, &prchdir_out_t->_pwrpc_return_))
		return 0;

	return 1;
}

